:- use_module('prolog/modules/vanilla.pl',[msos_steps/3 as vanilla_steps]).
:- use_module('prolog/modules/refocused.pl',[msos_steps/3 as refocused_steps]).
:- use_module('prolog/modules/pbs.pl',[msos_steps/3 as pb_steps]).

:- consult('prolog/lib/msos.pl').
:- consult('prolog/lib/label_sem.pl').
:- consult('prolog/example_programs').

test :-
	( nest_left_assoc_catch_exc(9,R0),init_label(L0),time(vanilla_steps(R0,L0,X0)),print(X0),!,
	  nest_left_assoc_catch_exc(9,R0),init_label(L0),time(refocused_steps(R0,L0,X0)),print(X0),!,
	  nest_left_assoc_add(20,A0),init_label(B0),time(pb_steps(A0,B0,C0)),print(C0),!,
	  nest_left_assoc_add(20,A0),init_label(B0),time(vanilla_steps(A0,B0,C0)),print(C0),!,
	  nest_left_assoc_add(20,A0),init_label(B0),time(refocused_steps(A0,B0,C0)),print(C0),!,
	  nest_left_assoc_catch_exc(9,R0),init_label(L0),time(pb_steps(R0,L0,X0)),print(X0),!,
	  nest_left_assoc_abs_nest_throw(100,R1),init_label(L1),time(vanilla_steps(R1,L1,X1)),print(X1),!,
	  nest_left_assoc_abs_nest_throw(100,R1),init_label(L1),time(refocused_steps(R1,L1,X1)),print(X1),!,
	  nest_left_assoc_abs_nest_throw(100,R1),init_label(L1),time(pb_steps(R1,L1,X1)),print(X1),!,
	  fib(3,R2),init_label(L2),time(vanilla_steps(R2,L2,X2)),print_result(L2,X2),!,
	  fib(3,R2),init_label(L2),time(refocused_steps(R2,L2,X2)),print_result(L2,X2),!,
	  fib(3,R2),init_label(L2),time(pb_steps(R2,L2,X2)),print_result(L2,X2),!,
	  fib(4,R3),init_label(L3),time(vanilla_steps(R3,L3,X3)),print_result(L3,X3),!,
	  fib(4,R3),init_label(L3),time(refocused_steps(R3,L3,X3)),print_result(L3,X3),!,
	  fib(4,R3),init_label(L3),time(pb_steps(R3,L3,X3)),print_result(L3,X3),!,
	  fib(5,R4),init_label(L4),time(vanilla_steps(R4,L4,X4)),print_result(L4,X4),!,
	  fib(5,R4),init_label(L4),time(refocused_steps(R4,L4,X4)),print_result(L4,X4),!,
	  fib(5,R4),init_label(L4),time(pb_steps(R4,L4,X4)),print_result(L4,X4),!,
	  fib(6,R5),init_label(L5),time(vanilla_steps(R5,L5,X5)),print_result(L5,X5),!,
	  fib(6,R5),init_label(L5),time(refocused_steps(R5,L5,X5)),print_result(L5,X5),!,
	  fib(6,R5),init_label(L5),time(pb_steps(R5,L5,X5)),print_result(L5,X5),!,
	  fac(3,R6),init_label(L6),time(vanilla_steps(R6,L6,X6)),print_result(L6,X6),!,
	  fac(3,R6),init_label(L6),time(refocused_steps(R6,L6,X6)),print_result(L6,X6),!,
	  fac(3,R6),init_label(L6),time(pb_steps(R6,L6,X6)),print_result(L6,X6),!,
	  fac(4,R7),init_label(L7),time(vanilla_steps(R7,L7,X7)),print_result(L7,X7),!,
	  fac(4,R7),init_label(L7),time(refocused_steps(R7,L7,X7)),print_result(L7,X7),!,
	  fac(4,R7),init_label(L7),time(pb_steps(R7,L7,X7)),print_result(L7,X7),!,
	  fac(5,R8),init_label(L8),time(vanilla_steps(R8,L8,X8)),print_result(L8,X8),!,
	  fac(5,R8),init_label(L8),time(refocused_steps(R8,L8,X8)),print_result(L8,X8),!,
	  fac(5,R8),init_label(L8),time(pb_steps(R8,L8,X8)),print_result(L8,X8),!,
	  fac(6,R9),init_label(L9),time(vanilla_steps(R9,L9,X9)),print_result(L9,X9),!,
	  fac(6,R9),init_label(L9),time(refocused_steps(R9,L9,X9)),print_result(L9,X9),!,
	  fac(6,R9),init_label(L9),time(pb_steps(R9,L9,X9)),print_result(L9,X9),!,
	  print_1_2_3(R10),init_label(L10),time(vanilla_steps(R10,L10,X10)),print_result(L10,X10),!,
	  print_1_2_3(R10),init_label(L10),time(refocused_steps(R10,L10,X10)),print_result(L10,X10),!,
	  print_1_2_3(R10),init_label(L10),time(pb_steps(R10,L10,X10)),print_result(L10,X10),!,
	  for_fib(3,R11),init_label(L11),time(vanilla_steps(R11,L11,X11)),print_result(L11,X11),!,
	  for_fib(3,R11),init_label(L11),time(refocused_steps(R11,L11,X11)),print_result(L11,X11),!,
	  for_fib(3,R11),init_label(L11),time(pb_steps(R11,L11,X11)),print_result(L11,X11),!,
	  for_fib(4,R12),init_label(L12),time(vanilla_steps(R12,L12,X12)),print_result(L12,X12),!,
	  for_fib(4,R12),init_label(L12),time(refocused_steps(R12,L12,X12)),print_result(L12,X12),!,
	  for_fib(4,R12),init_label(L12),time(pb_steps(R12,L12,X12)),print_result(L12,X12),!,
	  for_fib(5,R13),init_label(L13),time(vanilla_steps(R13,L13,X13)),print_result(L13,X13),!,
	  for_fib(5,R13),init_label(L13),time(refocused_steps(R13,L13,X13)),print_result(L13,X13),!,
	  for_fib(5,R13),init_label(L13),time(pb_steps(R13,L13,X13)),print_result(L13,X13),!,
	  for_fib(6,R14),init_label(L14),time(vanilla_steps(R14,L14,X14)),print_result(L14,X14),!,
	  for_fib(6,R14),init_label(L14),time(refocused_steps(R14,L14,X14)),print_result(L14,X14),!,
	  for_fib(6,R14),init_label(L14),time(pb_steps(R14,L14,X14)),print_result(L14,X14),!,
	  for_fac(3,R15),init_label(L15),time(vanilla_steps(R15,L15,X15)),print_result(L15,X15),!,
	  for_fac(3,R15),init_label(L15),time(refocused_steps(R15,L15,X15)),print_result(L15,X15),!,
	  for_fac(3,R15),init_label(L15),time(pb_steps(R15,L15,X15)),print_result(L15,X15),!,
	  for_fac(4,R16),init_label(L16),time(vanilla_steps(R16,L16,X16)),print_result(L16,X16),!,
	  for_fac(4,R16),init_label(L16),time(refocused_steps(R16,L16,X16)),print_result(L16,X16),!,
	  for_fac(4,R16),init_label(L16),time(pb_steps(R16,L16,X16)),print_result(L16,X16),!,
	  for_fac(5,R17),init_label(L17),time(vanilla_steps(R17,L17,X17)),print_result(L17,X17),!,
	  for_fac(5,R17),init_label(L17),time(refocused_steps(R17,L17,X17)),print_result(L17,X17),!,
	  for_fac(5,R17),init_label(L17),time(pb_steps(R17,L17,X17)),print_result(L17,X17),!,
	  for_fac(6,R18),init_label(L18),time(vanilla_steps(R18,L18,X18)),print_result(L18,X18),!,
	  for_fac(6,R18),init_label(L18),time(refocused_steps(R18,L18,X18)),print_result(L18,X18),!,
	  for_fac(6,R18),init_label(L18),time(pb_steps(R18,L18,X18)),print_result(L18,X18),!,
	  nl,nl,nl,
	  print('*****************'),nl,
	  print('All tests passed!'),nl,
	  print('*****************'),nl
	).
